<template>
  <div class="container pt-5">
    <div class="input-block d-flex pb-5">
      <div class="flex-grow-1 ">
        <input type="text" :placeholder="placeholderString" class="w-100 p-3" v-model="todoText"
               @keydown.enter="addTodo" ref="todoText">
      </div>
      <button class="btn btn-success p-3 px-5 ms-3" @click="addTodo">Add</button>
      <button class="btn btn-danger p-3 px-5 ms-3" @click="removeTodo">Delete all</button>
    </div>
    <div class="filter-block"></div>
    <div class="list-block">

      <VList :items="todos" title="Todos list"
             @remove="removeItem"
      />
    </div>
  </div>

</template>

<script>

import VList from "@/components/VList.vue";

export default {
  name: 'App',
  components: {VList,},
  data: () => ({
    todoText: "",
    todos: [],
    placeholderString: 'Enter a name for the note',
  }),
  created() {
    this.getTodosFromLocalStorage()
  },
  methods: {

    addTodo() {
      const count = this.todos.filter(td => td.title === this.todoText).length
      if (!this.todoText.trim() || count) {
        this.clearTodoText()
        this.focusTodoText()
        return
      }
      const todo = {
        id: +(new Date()),
        title: this.todoText,
        completed: false,

      }
      this.todos.push(todo)
      this.clearTodoText()
      this.focusTodoText()
      this.saveToLocalStorage()

    },
    clearTodoText() {
      this.todoText = ''

    },
    focusTodoText() {
      this.$refs.todoText.focus()

    },
    saveToLocalStorage() {
      localStorage.setItem('todos', JSON.stringify(this.todos))
    },
    getTodosFromLocalStorage() {
      const todos = JSON.parse(localStorage.getItem('todos'))
      if (todos) this.todos = todos
    },

    removeTodo() {
      this.clearTodoText()
      this.focusTodoText()
      this.todos = []
      localStorage.clear()
    },
    removeItem(item) {
      this.todos = this.todos.filter(p => p.id !== item.id)
      this.saveToLocalStorage()

    },

  }

}
</script>

<style>


</style>
